unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, IdHTTP, StrUtils, Grids, XPMan;

type
  TPlayerSchedule = Array [1..7,0..23] of boolean;
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label2: TLabel;
    StringGrid1: TStringGrid;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    TrueEdit: TEdit;
    FalseEdit: TEdit;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    Edit2: TEdit;
    Button3: TButton;
    Button4: TButton;
    GroupBox4: TGroupBox;
    Label7: TLabel;
    Edit3: TEdit;
    Button5: TButton;
    Button6: TButton;
    GroupBox5: TGroupBox;
    Label8: TLabel;
    Edit4: TEdit;
    Button7: TButton;
    Button8: TButton;
    GroupBox6: TGroupBox;
    Label9: TLabel;
    Edit5: TEdit;
    Button9: TButton;
    Button10: TButton;
    GroupBox7: TGroupBox;
    Label10: TLabel;
    Edit6: TEdit;
    Button11: TButton;
    Button12: TButton;
    GroupBox8: TGroupBox;
    Label11: TLabel;
    Edit7: TEdit;
    Button13: TButton;
    Button14: TButton;
    GroupBox9: TGroupBox;
    Label12: TLabel;
    Edit8: TEdit;
    Button15: TButton;
    Button16: TButton;
    GroupBox10: TGroupBox;
    Label13: TLabel;
    Edit9: TEdit;
    Button17: TButton;
    Button18: TButton;
    GroupBox11: TGroupBox;
    Label14: TLabel;
    Edit10: TEdit;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure Edit8Change(Sender: TObject);
    procedure Edit9Change(Sender: TObject);
    procedure Edit10Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
  private
    { Private declarations }
  public
  PlayerListing:widestring;
  PlayerSchedules:Array[1..10] of TPlayerSchedule;
  SchedulesGot:Array[1..10] of Boolean;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
procedure GetHTML(Address:String; var HTMLGot:WideString; var errored:Boolean);
var
Http1:TIdHTTP;
begin
errored:=False;
Http1:=TIdHTTP.Create(nil);
try
Http1.Request.UserAgent:='User-Agent: NULL';
HtmlGot:=Http1.Get(Address);
except
errored:=True;
end;
Http1.Free;
end;

procedure GetPlayerSchedule(PlayerName:String; PlayerNumber:Integer; var workedout:Boolean);
var
errored:Boolean;
nickpos:Integer;
idpos,i,j:Integer;
lesspos:Integer;
nickno:String;
PlayerSchedulingHTML:WideString;
begin
workedout:=false;
nickpos:=Pos(PlayerName,Form1.PlayerListing);
if nickpos=0 then begin
                  Form1.RichEdit1.Lines.Add(PlayerName+' - nick not found in the listing!');
                  exit;
                  end
             else begin
                  idpos:=Posex('?id=',Form1.PlayerListing,nickpos-12);
                  lesspos:=Posex('>',Form1.PlayerListing,idpos);
                  nickno:=Copy(Form1.PlayerListing,idpos+4,lesspos-idpos-5);
                  GetHTML('http://suptg.thisisnotatrueending.com/playerview.html?id='+nickno,PlayerSchedulingHTML,errored);
                  If errored then begin
                                  Form1.RichEdit1.Lines.Add(PlayerName+' - failed to get player info page!');
                                  exit;
                                  end;
                  nickpos:=Pos('<td>Saturday</td>',PlayerSchedulingHTML);
                  lesspos:=Posex('</table>',PlayerSchedulingHTML,nickpos);
                  PlayerSchedulingHTML:=Copy(PlayerSchedulingHTML,nickpos,lesspos-nickpos-1);

                  {Form1.RichEdit1.Lines.Add('http://suptg.thisisnotatrueending.com/playerview.html?id='+nickno);
                  Form1.Richedit1.Lines.Add(PlayerSchedulingHTML);}

                  nickpos:=0;
                  For i:=0 to 23 do
                  For j:=1 to 7 do begin
                                   lesspos:=Posex(':#',PlayerSchedulingHTML,nickpos);
                                   nickpos:=Posex(';"',PlayerSchedulingHTML,lesspos);
                                   nickno:=Copy(PlayerSchedulingHTML,lesspos+2,nickpos-lesspos-2);
                                   If nickno=Form1.TrueEdit.Text then Form1.PlayerSchedules[PlayerNumber][j,i]:=true
                                                                 else if nickno=Form1.FalseEdit.Text then Form1.PlayerSchedules[PlayerNumber][j,i]:=false
                                                                                                     else begin
                                                                                                          Form1.RichEdit1.Lines.Add('Oh hey, look, we have a cell that''s colored as neither free not busy. Make sure you got the colors in the settings right!');
                                                                                                          exit;
                                                                                                          end;
                                   //Form1.RichEdit1.Lines.Add(IntToStr(j)+' '+IntToStr(i)+' '+nickno);
                                   end;
                  workedout:=true;
                  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
errored:Boolean;
i,j,k:Integer;
begin
errored:=true;
GetHtml('http://suptg.thisisnotatrueending.com/players.html',Form1.PlayerListing,errored);
If errored then Richedit1.Lines.Add('Error getting player listing! Try restarting...')
           else Richedit1.Lines.Add('Got player listing!');
For i:=1 to 10 do
For j:=1 to 7 do
For k:=0 to 23 do
Form1.PlayerSchedules[i][j,k]:=False;
For i:=1 to 10 do Form1.SchedulesGot[i]:=False;
Stringgrid1.Cells[1,0]:='Sunday';
Stringgrid1.Cells[2,0]:='Monday';
Stringgrid1.Cells[3,0]:='Tuesday';
Stringgrid1.Cells[4,0]:='Wednesday';
Stringgrid1.Cells[5,0]:='Thursday';
Stringgrid1.Cells[6,0]:='Friday';
Stringgrid1.Cells[7,0]:='Saturday';
For i:=0 to 23 do  StringGrid1.Cells[0,i+1]:=IntToStr(i)+':00-'+IntToStr(i)+':59';
end;

procedure ShowSchedule(PlayerNumber:Integer);
var
i,j:Integer;
begin
For i:=1 to 7 do
For j:=0 to 23 do
If Form1.PlayerSchedules[PlayerNumber][i,j]=true then Form1.Stringgrid1.Cells[i,j+1]:='1'
                                                 else Form1.Stringgrid1.Cells[i,j+1]:='0';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
workedout:Boolean;
begin
If Form1.SchedulesGot[1]=False then begin
                                    GetPlayerSchedule(Edit1.Text,1,workedout);
                                    if workedout then begin
                                                      Button1.Caption:='Show schedule';
                                                      Button2.Enabled:=true;
                                                      Form1.SchedulesGot[1]:=true;
                                                      Richedit1.Lines.Add(Edit1.Text+' - got player schedule!');
                                                      end
                                                 else begin
                                                      Richedit1.Lines.Add(Edit1.Text+' - failed to get player schedule!');
                                                      end;
                                    end
                               else begin
                                    Label3.Caption:=Edit1.Text+'''s schedule, EST';
                                    ShowSchedule(1);
                                    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
workedout:Boolean;
begin
GetPlayerSchedule(Edit1.Text,1,workedout);
If workedout then Richedit1.Lines.Add(Edit1.Text+' - got player schedule!')
             else Richedit1.Lines.Add(Edit1.Text+' - failed to get player schedule!');
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
Button1.Enabled:=True;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
Button3.Enabled:=True;
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
Button5.Enabled:=True;
end;

procedure TForm1.Edit4Change(Sender: TObject);
begin
Button7.Enabled:=True;
end;

procedure TForm1.Edit5Change(Sender: TObject);
begin
Button9.Enabled:=True;
end;

procedure TForm1.Edit6Change(Sender: TObject);
begin
Button11.Enabled:=True;
end;

procedure TForm1.Edit7Change(Sender: TObject);
begin
Button13.Enabled:=True;
end;

procedure TForm1.Edit8Change(Sender: TObject);
begin
Button15.Enabled:=True;
end;

procedure TForm1.Edit9Change(Sender: TObject);
begin
Button17.Enabled:=True;
end;

procedure TForm1.Edit10Change(Sender: TObject);
begin
Button19.Enabled:=True;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
workedout:Boolean;
begin
If Form1.SchedulesGot[2]=False then begin
                                    GetPlayerSchedule(Edit2.Text,2,workedout);
                                    if workedout then begin
                                                      Button3.Caption:='Show schedule';
                                                      Button4.Enabled:=true;
                                                      Form1.SchedulesGot[2]:=true;
                                                      Richedit1.Lines.Add(Edit2.Text+' - got player schedule!');
                                                      end
                                                 else begin
                                                      Richedit1.Lines.Add(Edit2.Text+' - failed to get player schedule!');
                                                      end;
                                    end
                               else begin
                                    Label3.Caption:=Edit1.Text+'''s schedule, EST';
                                    ShowSchedule(2);
                                    end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
workedout:Boolean;
begin
If Form1.SchedulesGot[3]=False then begin
                                    GetPlayerSchedule(Edit3.Text,3,workedout);
                                    if workedout then begin
                                                      Button5.Caption:='Show schedule';
                                                      Button6.Enabled:=true;
                                                      Form1.SchedulesGot[3]:=true;
                                                      Richedit1.Lines.Add(Edit3.Text+' - got player schedule!');
                                                      end
                                                 else begin
                                                      Richedit1.Lines.Add(Edit3.Text+' - failed to get player schedule!');
                                                      end;
                                    end
                               else begin
                                    Label3.Caption:=Edit3.Text+'''s schedule, EST';
                                    ShowSchedule(3);
                                    end;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
workedout:Boolean;
begin
If Form1.SchedulesGot[4]=False then begin
                                    GetPlayerSchedule(Edit4.Text,4,workedout);
                                    if workedout then begin
                                                      Button7.Caption:='Show schedule';
                                                      Button8.Enabled:=true;
                                                      Form1.SchedulesGot[4]:=true;
                                                      Richedit1.Lines.Add(Edit4.Text+' - got player schedule!');
                                                      end
                                                 else begin
                                                      Richedit1.Lines.Add(Edit4.Text+' - failed to get player schedule!');
                                                      end;
                                    end
                               else begin
                                    Label3.Caption:=Edit4.Text+'''s schedule, EST';
                                    ShowSchedule(4);
                                    end;
end;

procedure TForm1.Button9Click(Sender: TObject);
var
workedout:Boolean;
begin
If Form1.SchedulesGot[5]=False then begin
                                    GetPlayerSchedule(Edit5.Text,5,workedout);
                                    if workedout then begin
                                                      Button9.Caption:='Show schedule';
                                                      Button10.Enabled:=true;
                                                      Form1.SchedulesGot[5]:=true;
                                                      Richedit1.Lines.Add(Edit5.Text+' - got player schedule!');
                                                      end
                                                 else begin
                                                      Richedit1.Lines.Add(Edit5.Text+' - failed to get player schedule!');
                                                      end;
                                    end
                               else begin
                                    Label3.Caption:=Edit5.Text+'''s schedule, EST';
                                    ShowSchedule(5);
                                    end;
end;

procedure TForm1.Button11Click(Sender: TObject);
var
workedout:Boolean;
begin
If Form1.SchedulesGot[6]=False then begin
                                    GetPlayerSchedule(Edit6.Text,6,workedout);
                                    if workedout then begin
                                                      Button11.Caption:='Show schedule';
                                                      Button12.Enabled:=true;
                                                      Form1.SchedulesGot[6]:=true;
                                                      Richedit1.Lines.Add(Edit6.Text+' - got player schedule!');
                                                      end
                                                 else begin
                                                      Richedit1.Lines.Add(Edit6.Text+' - failed to get player schedule!');
                                                      end;
                                    end
                               else begin
                                    Label3.Caption:=Edit6.Text+'''s schedule, EST';
                                    ShowSchedule(6);
                                    end;
end;

procedure TForm1.Button13Click(Sender: TObject);
var
workedout:Boolean;
begin
If Form1.SchedulesGot[7]=False then begin
                                    GetPlayerSchedule(Edit7.Text,7,workedout);
                                    if workedout then begin
                                                      Button13.Caption:='Show schedule';
                                                      Button14.Enabled:=true;
                                                      Form1.SchedulesGot[7]:=true;
                                                      Richedit1.Lines.Add(Edit7.Text+' - got player schedule!');
                                                      end
                                                 else begin
                                                      Richedit1.Lines.Add(Edit7.Text+' - failed to get player schedule!');
                                                      end;
                                    end
                               else begin
                                    Label3.Caption:=Edit7.Text+'''s schedule, EST';
                                    ShowSchedule(7);
                                    end;
end;

procedure TForm1.Button15Click(Sender: TObject);
var
workedout:Boolean;
begin
If Form1.SchedulesGot[8]=False then begin
                                    GetPlayerSchedule(Edit8.Text,8,workedout);
                                    if workedout then begin
                                                      Button15.Caption:='Show schedule';
                                                      Button16.Enabled:=true;
                                                      Form1.SchedulesGot[8]:=true;
                                                      Richedit1.Lines.Add(Edit8.Text+' - got player schedule!');
                                                      end
                                                 else begin
                                                      Richedit1.Lines.Add(Edit8.Text+' - failed to get player schedule!');
                                                      end;
                                    end
                               else begin
                                    Label3.Caption:=Edit8.Text+'''s schedule, EST';
                                    ShowSchedule(8);
                                    end;
end;

procedure TForm1.Button17Click(Sender: TObject);
var
workedout:Boolean;
begin
If Form1.SchedulesGot[9]=False then begin
                                    GetPlayerSchedule(Edit9.Text,9,workedout);
                                    if workedout then begin
                                                      Button17.Caption:='Show schedule';
                                                      Button18.Enabled:=true;
                                                      Form1.SchedulesGot[9]:=true;
                                                      Richedit1.Lines.Add(Edit9.Text+' - got player schedule!');
                                                      end
                                                 else begin
                                                      Richedit1.Lines.Add(Edit9.Text+' - failed to get player schedule!');
                                                      end;
                                    end
                               else begin
                                    Label3.Caption:=Edit9.Text+'''s schedule, EST';
                                    ShowSchedule(9);
                                    end;
end;

procedure TForm1.Button19Click(Sender: TObject);
var
workedout:Boolean;
begin
If Form1.SchedulesGot[10]=False then begin
                                    GetPlayerSchedule(Edit10.Text,10,workedout);
                                    if workedout then begin
                                                      Button19.Caption:='Show schedule';
                                                      Button20.Enabled:=true;
                                                      Form1.SchedulesGot[10]:=true;
                                                      Richedit1.Lines.Add(Edit10.Text+' - got player schedule!');
                                                      end
                                                 else begin
                                                      Richedit1.Lines.Add(Edit10.Text+' - failed to get player schedule!');
                                                      end;
                                    end
                               else begin
                                    Label3.Caption:=Edit10.Text+'''s schedule, EST';
                                    ShowSchedule(10);
                                    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
workedout:Boolean;
begin
GetPlayerSchedule(Edit2.Text,2,workedout);
If workedout then Richedit1.Lines.Add(Edit2.Text+' - got player schedule!')
             else Richedit1.Lines.Add(Edit2.Text+' - failed to get player schedule!');
end;

procedure TForm1.Button6Click(Sender: TObject);
var
workedout:Boolean;
begin
GetPlayerSchedule(Edit3.Text,3,workedout);
If workedout then Richedit1.Lines.Add(Edit3.Text+' - got player schedule!')
             else Richedit1.Lines.Add(Edit3.Text+' - failed to get player schedule!');
end;

procedure TForm1.Button8Click(Sender: TObject);
var
workedout:Boolean;
begin
GetPlayerSchedule(Edit4.Text,4,workedout);
If workedout then Richedit1.Lines.Add(Edit4.Text+' - got player schedule!')
             else Richedit1.Lines.Add(Edit4.Text+' - failed to get player schedule!');
end;

procedure TForm1.Button10Click(Sender: TObject);
var
workedout:Boolean;
begin
GetPlayerSchedule(Edit5.Text,5,workedout);
If workedout then Richedit1.Lines.Add(Edit5.Text+' - got player schedule!')
             else Richedit1.Lines.Add(Edit5.Text+' - failed to get player schedule!');
end;

procedure TForm1.Button12Click(Sender: TObject);
var
workedout:Boolean;
begin
GetPlayerSchedule(Edit6.Text,6,workedout);
If workedout then Richedit1.Lines.Add(Edit6.Text+' - got player schedule!')
             else Richedit1.Lines.Add(Edit6.Text+' - failed to get player schedule!');
end;

procedure TForm1.Button14Click(Sender: TObject);
var
workedout:Boolean;
begin
GetPlayerSchedule(Edit7.Text,7,workedout);
If workedout then Richedit1.Lines.Add(Edit7.Text+' - got player schedule!')
             else Richedit1.Lines.Add(Edit7.Text+' - failed to get player schedule!');
end;

procedure TForm1.Button16Click(Sender: TObject);
var
workedout:Boolean;
begin
GetPlayerSchedule(Edit8.Text,8,workedout);
If workedout then Richedit1.Lines.Add(Edit8.Text+' - got player schedule!')
             else Richedit1.Lines.Add(Edit8.Text+' - failed to get player schedule!');
end;

procedure TForm1.Button18Click(Sender: TObject);
var
workedout:Boolean;
begin
GetPlayerSchedule(Edit9.Text,9,workedout);
If workedout then Richedit1.Lines.Add(Edit9.Text+' - got player schedule!')
             else Richedit1.Lines.Add(Edit9.Text+' - failed to get player schedule!');
end;

procedure TForm1.Button20Click(Sender: TObject);
var
workedout:Boolean;
begin
GetPlayerSchedule(Edit10.Text,10,workedout);
If workedout then Richedit1.Lines.Add(Edit10.Text+' - got player schedule!')
             else Richedit1.Lines.Add(Edit10.Text+' - failed to get player schedule!');
end;

procedure TForm1.Button21Click(Sender: TObject);
var
CanAttend:Array[1..7,0..23] of Integer;
i,j,k:Integer;
begin
If (edit1.Text<>'') and (Form1.SchedulesGot[1]=False) then Button1Click(Self);
Application.ProcessMessages;
If (edit2.Text<>'') and (Form1.SchedulesGot[2]=False) then Button3Click(Self);
Application.ProcessMessages;
If (edit3.Text<>'') and (Form1.SchedulesGot[3]=False) then Button5Click(Self);
Application.ProcessMessages;
If (edit4.Text<>'') and (Form1.SchedulesGot[4]=False) then Button7Click(Self);
Application.ProcessMessages;
If (edit5.Text<>'') and (Form1.SchedulesGot[5]=False) then Button9Click(Self);
Application.ProcessMessages;
If (edit6.Text<>'') and (Form1.SchedulesGot[6]=False) then Button11Click(Self);
Application.ProcessMessages;
If (edit7.Text<>'') and (Form1.SchedulesGot[7]=False) then Button13Click(Self);
Application.ProcessMessages;
If (edit8.Text<>'') and (Form1.SchedulesGot[8]=False) then Button15Click(Self);
Application.ProcessMessages;
If (edit9.Text<>'') and (Form1.SchedulesGot[9]=False) then Button17Click(Self);
Application.ProcessMessages;
If (edit10.Text<>'') and (Form1.SchedulesGot[10]=False) then Button19Click(Self);
Application.ProcessMessages;

For i:=1 to 7 do
For j:=0 to 23 do
CanAttend[i,j]:=0;

For i:=1 to 7 do
For j:=0 to 23 do
For k:=1 to 10 do
If Form1.PlayerSchedules[k][i,j]=True then CanAttend[i,j]:=CanAttend[i,j]+1;

k:=0;
For i:=1 to 7 do
For j:=0 to 23 do
If CanAttend[i,j]>k then k:=CanAttend[i,j];

//StringGrid1.Font.Style:=[fsBold];
StringGrid1.Font.Color:=ClBlack;
Label3.Caption:='Number of players than can attend in each hour, EST:';
Form1.RichEdit1.Lines.Add('Estimated the times all players can attend.');
For i:=1 to 7 do
For j:=0 to 23 do
begin
If (k>0) and (CanAttend[i,j]<k) then StringGrid1.Font.Color:=ClGray;
If (k>0) and (CanAttend[i,j]<k) then StringGrid1.Font.Color:=ClBlack;
StringGrid1.Cells[i,j+1]:=IntToStr(CanAttend[i,j]);
end;


end;

end.
